framework.browser.attachEvent(framework.browser.BEFORENAVIGATE, function(event) {
	App.trigger('before-navigate', event);
});

framework.browser.attachEvent(framework.browser.DOCUMENTCOMPLETE, function(event) {
		if (!App.has('tabId') || event.tabId === App.get('tabId') || framework.browser.name === 'Internet Explorer') {
		App.set({
			url: event.url,
			tabId: event.tabId
		});
	}
});

framework.browser.attachEvent(framework.browser.TABCHANGED, function(event) {
	App.trigger('tab-change', event);
	App.set({
		url: event.url,
		tabId: event.tabId
	});
});

framework.extension.attachEvent('tab-change', function(event) {
	App.set({
		url: event.url,
		tabId: event.tabId
	});
});

framework.extension.attachEvent('set-credentials', function(event) {
	var changed = App.get('usertoken') != event.data;
	App.set({'usertoken': event.data});
	framework.extension.broadcast && framework.extension.broadcast.postMessage(event);
});

framework.extension.attachEvent('login', function(event) {
	App.singInPopup('https://www.couponcabin.com/login/?' + UTM_TAIL, 600, 670, event.tabId);
});

framework.extension.attachEvent('singInPopup', function(event) {
	App.singInPopup(event.data.url, 600, 670, event.tabId);
});

framework.extension.attachEvent('get-merchant', function(event, callback) {
	if(event.url.indexOf('http') == 0 && App) {
		if (event.data.check) {
			App.trigger('check-url', event);
		}
		
		var merchant = App.merchants.match(getDomain(event.data.url || event.url));
		if (merchant) {
			
			var tab = tabs.findWhere({ id : event.tabId });
			if (tab && tab.has("deeplink")) {
				var deeplink = tab.get("deeplink");
				tab.immediateReset();
				
				framework.browser.navigate({
					tabId : event.tabId,
					url : deeplink
				});
				
				return;
			}

			merchant.set({
				slider: true
			});
			
			$(App.blockedSliders).each(function(i) {
				if (merchant.get('domain_name') && merchant.get('domain_name').toLowerCase() == App.blockedSliders[i]) {
					merchant.set({
						slider: false
					});
				} else {
					if (DEBUG) {
						console.log('merchant.domain_name', merchant.get('domain_name'));
					}
				}
			});
			if (App.get('usertoken')) {
				if (merchant.get('id')) {
					App.user.url = 'https://my.www.couponcabin.com/api/u/' + merchant.get('id') + '/';
					App.user.fetch({
						success: function(data) {
							if (DEBUG) {
								console.log('App.user.fetch', App.user);
							}
							callback({
								merchant: merchant.toJSON(),
								user: App.user.toJSON(),
								usertoken: App.get('usertoken'),
								extensionUID: App.get('uid')
							});
						},
						error: function(data) {
							if (DEBUG) {
								console.warn('App.user.fetch ERROR');
							}
							callback({
								merchant: merchant.toJSON(),
								usertoken: App.get('usertoken'),
								extensionUID: App.get('uid')
							});
						}
					});
					
					
					/*App.user = {
						name: "user",
						user_bonus: "0.00",
						payment_threshold: "10.00",
						payment_mathod: "PayPal",
						lifetime_cash_back: "384.96",
						pending_cash_back: "43.83",
						payable_cash_back: "3.99"
					};
					callback({
						merchant: merchant.toJSON(),
						user: App.user,
						usertoken: App.get('usertoken'),
						extensionUID: App.get('uid')
					});*/
					
					
				} else {
					callback({
						merchant: merchant.toJSON(),
						usertoken: App.get('usertoken'),
						extensionUID: App.get('uid')
					});
				}
			} else {
				callback({
					merchant: merchant.toJSON(),
					//user: App.user.toJSON(),
					usertoken: App.get('usertoken'),
					extensionUID: App.get('uid')
				});
			}
		}
	}
});

framework.extension.attachEvent('close-slider', function(event, callback) {
	var merchant = App.merchants.findWhere({display_name: event.data.merchant.display_name});
	if (merchant) {
		merchant.set({
			sidetab : event.data.merchant.sidetab
		});
	}
});

framework.extension.attachEvent('open-slider', function(event, callback) {
	var merchant = App.merchants.findWhere({display_name: event.data.merchant.display_name});
	if (merchant) {
		merchant.set({
			sidetab: event.data.merchant.sidetab
		});
	}
});

framework.extension.broadcast && framework.extension.broadcast.onMessage(function(event) {
	App.set({'usertoken': event.data});
});

var tabs = new Tabs();
tabs.on("change:domain", function(tab, domain, options) {
	if (!domain) return;
	
	tab.reset();
});

framework.extension.attachEvent("activate-cashback", function(event) {
	var tab = tabs.findWhere({ id : event.tabId });
	if (tab) {
		tab.set("deeplink", event.url);
	}
	
	framework.browser.navigate({
		url : event.data.activationUrl, 
		tabId : event.tabId || framework.browser.CURRENTTAB
	});
});

framework.extension.attachEvent('dont-show-slider', function(event, callback) {
	if (event.data) {
		App.trigger('dont-show-slider', event);
	}
});

$.support.cors = true;
window.App = new AppModel();
window.setTimeout(function() {
	window.App.fetch();
}, 1000);