/**
 * Addons framework v2.0.0
 *
 * This Software is licensed under open source and commercial licenses.
 * For the Open Source License terms please refer to http://besttoolbars.net/os_license/
 * For the Commercial License terms please refer to http://besttoolbars.net/commercial_license/
 * Request details on licensing at http://www.besttoolbars.net/products/addon_framework/
 *
 * THE SOFTWARE IS PROVIDED "AS IS" WITH ALL FAULTS. BESTTOOLBARS HEREBY DISCLAIMS ALL REPRESENTATIONS,
 * WARRANTIES  AND  CONDITIONS,  EXPRESS  OR  IMPLIED,  WITH RESPECT TO THE SOFTWARE INCLUDING, WITHOUT
 * LIMITATION,  ANY  WARRANTIES  OR CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT.  BESTTOOLBARS  DOES  NOT WARRANT THAT THE USE OR OPERATION OF THE SOFTWARE WILL BE
 * UNINTERRUPTED  OR  ERROR FREE. LICENSEE IS SOLELY RESPONSIBLE FOR DETERMINING THE APPROPRIATENESS OF
 * USING  THE  SOFTWARE. LICENSEE ASSUMES ALL RISKS ASSOCIATED WITH USE OF THE SOFTWARE, INCLUDING, BUT
 * NOT  LIMITED  TO,  THE RISKS OF PROGRAM ERRORS, DAMAGE TO OR LOSS OF DATA, PROGRAMS OR EQUIPMENT AND
 * UNAVAILABILITY OR INTERRUPTION OF OPERATIONS.
 *
 */

(function() {
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
							.getService(Components.interfaces.nsIPromptService);
	var screenMan = Components.classes["@mozilla.org/gfx/screenmanager;1"]
					.getService(Components.interfaces.nsIScreenManager);
	var left = {}, top = {}, screenWidth = {}, screenHeight = {};
	screenMan.primaryScreen.GetRect(left, top, screenWidth, screenHeight);

	var page = document.getElementById("optionsPage");
	var windowLoaded = false;
	var configReady = false;
	var config = null;

	var file = Components['stack'].filename;
	var directory = file['replace'](/.* -> |[^\/]+$/g, "");
	var scriptName = directory + 'config.json';
	var req = Components['classes']["@mozilla.org/xmlextras/xmlhttprequest;1"]['createInstance']();
	req.open('GET', scriptName, true);
	req.overrideMimeType('text/javascript');
	req.onreadystatechange = function (e) {
		if (e.target.readyState == 4) {
			config = JSON.parse(e.target.responseText);

			var height = config['optionsPageHeight'] ? parseInt(config['optionsPageHeight']) : screenHeight.value * 0.6;
			var width = config['optionsPageWidth'] ? parseInt(config['optionsPageWidth']) : screenWidth.value * 0.6;

			page['setAttribute']('height', height);
			page['setAttribute']('width', width);

			window.screenX = (screenWidth.value - width) / 2;
			window.screenY = (screenHeight.value - height) / 2;

			configReady = true;
			if (windowLoaded) {
				applyFramework();
			}
		}
	};
	req.send();

	window.addEventListener('load', function() {
		windowLoaded = true;
		if (configReady) {
			applyFramework();
		}
	}, false);

	function applyFramework() {
		var mainWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"]
			['getService'](Components['interfaces']['nsIWindowMediator'])
			['getMostRecentWindow']('navigator:browser');
	
		var background = mainWindow.document.getElementById(config['packageName'] + '-background');
		var _ci_ = background.contentWindow[config['interfaceName']];
  
		var browserNode = document.getElementById("browserNode");
		browserNode.contentWindow.location.href = 'chrome://' + config['packageName'] + '/content/' + config['optionsPage'];
		timer = window.setInterval(function() {
			if (browserNode.contentWindow.location.href != 'about:blank') {
				browserNode.contentWindow.close = function() {
					window.close();
				};
				browserNode.contentWindow[config['interfaceName']] = _ci_;
				window.clearInterval(timer);
			}
		}, 0);
	}
})();
