var SerpView = BackboneContent.View.extend({
	template: Handlebars.templates.serp,
	render: function() {
		return this.$el.prepend(this.template(this.model));
	}
});

function AddonSERPOverlay(){
	//-- Rules to detect SERP pages and parse out correct URLs from these pages
	var config = [{
		domain: 'search.yahoo.com',
		rx: /\/search.*(?:fr|p)=.*/,
		link: 'div#main h3 a',
		hrefrx: /=(https?:\/\/.+?)\/\//
	},{
		domain: 'www.bing.com',
		rx: /\/?search/,
		link: '#b_results > li > h2 > a'
	},{
		domain: 'google.',
		rx: /^http(?:s)?:\/\/(?:www\.|encrypted\.)?google(?:\.com?)?\..{2,3}\/#?(?:search|webhp|sclient|hl|)?.*[&]?q=([^&]*)/,
		div: 'div.rc', 
		link: '.rc > .r > a, .g > .r > a'
	},{
		domain: 'ask.com',
		rx: /ask\.com\/.*?[&?]q=/,
		div: 'div.rc', 
		link: '.wresult h3 > a'
	}];

	function renderHTML(node, merchant, serp){
		setTimeout(function(){//clear context in FF
		if(!App.css){
			injectCSS();
			App.css = true;
		}
		(new SerpView({
			model: merchant,
			el: node
		})).render();
		},1);
	}

	$.each(config, function(i, serp){
		if(window.location.href.indexOf(serp.domain) >= 0){
			if(serp.rx.test(window.location.href)){
				$(serp.link).each(function(){
					if(this.getAttribute('href') && this.getAttribute('couponcabin-serp-processed') != '1') {
						this.setAttribute('couponcabin-serp-processed', '1');
						var id, node = this;
						var href = node.getAttribute('href');
						if (href.indexOf('[^_]url=http') > 0){
							href = escape(href.match(/[^_]url=([^&]+)/).pop());
						} else if (href.indexOf('?q=http') > 0){
							href = escape(href.match(/\?q=([^&]+)/).pop());
						} else if (href.indexOf("=http") > 0) {
							href = unescape('http' + href.match(/=http([^&]+)/).pop());
						}
						framework.extension.fireEvent('get-merchant', { data: {
							url: href
						}}, function(data) {
							if (data.merchant && data.merchant.serp_text) {
								renderHTML(node, data.merchant, serp);
							}
						});
					}
				});
				return false;
			}
		}
	});
}


//---------------------------------------------------
//-- Set up page analyzer 

//$(window).bind('load hashchange', AddonSERPOverlay);

(function refreshSerp() {
	AddonSERPOverlay();
	window.setTimeout(refreshSerp,1500);
})();

