
var SidetabView = BackboneContent.View.extend({
	
	template : Handlebars.templates.sidetab,
	
	initialize : function() {
		
		var self = this;
		
		var onClick = function() { self.trigger("show-parent"); };
		
		this.onMouseOver = _.throttle(function() {
			self.maximize();
		}, 100, {
			leading : false
		});
		
		this.onMouseOut = _.debounce(function() {
			self.minimize();
		}, 500);
		
		this.events = {
			"click" : onClick
			// , "mouseover" : this.onMouseOver
			// , "mouseout" : this.onMouseOut
		};
		
	},
	
	delegateEvents : function() {
		var self = this;
		
		if (BROWSER_NAME_IE === framework.browser.name) {
			_.each(
				this.events,
				function(callback, selector) {
					try {
						//-- TODO: make universal solution
						if ( /^click$/i.test(selector) ) {
							self.el.onclick = callback;
						} else if ( /^mouseover$/i.test(selector) ) {
							self.el.onmouseover = callback;
						} else if ( /^mouseout$/i.test(selector) ) {
							self.el.onmouseout = callback;
						}
					} catch(e) {}
				}
			);
		} else {
			return BackboneContent.View.prototype.delegateEvents.apply(this, arguments);
		}
		
		return this;
	},
	
	render : function() {
		
		this.setElement(
			$( this.template(this.model) )
				.insertAfter('head')
				.get(0)
		);
		
		// this.$el.hover(function() {
			// $(this).data("hover", 1);
		// }, function() {
			// $(this).data("hover", 0);
		// });
		
		// this.height = this.$el.height();
		this.height = 20; //-- NOTE: see in the .LESS templates height
		
		return this;
		
	},
	
	maximize : function() {
		// this.$el.data("hover") && this.$el.animate({
		if (this.$el.data("hover")) {
			this.$el.animate({
				"top" : "0px"
			}, {
				"duration" : 250
			});
		}
	},
	
	minimize : function() {
		// !this.$el.data("hover") && this.$el.animate({
		if (!this.$el.data("hover")) {
			this.$el.animate({
				"top" : "-10px"
			}, {
				"duration" : 250
			});
		}
	},
	
	show : function() {
		this.$el.animate({
			"top" : "0px"
		}, {
			"duration" : 150,
			"complete" : _.bind(function() {
				this.delegateEvents();
			}, this)
		});
	},
	
	hide : function(callback) {
		this.$el.animate({
			"top" : "-" + ( 10 + this.height ) + "px"
		}, {
			"duration" : 150,
			"complete" : function() {
				//callback && callback();
				if (callback) callback();
			}
		});
	}
	
});

