var SliderView = BackboneContent.View.extend({
	template: Handlebars.templates.slider,
	showInterval: 4000,
	showed: false,
	absoluteElements: [],
	initialize: function() {
		var this_ = this;
		var close = _.bind(function() {
			framework.extension.fireEvent('google-analytics-event', {
				data: {
					uid: this_.model.extensionUID,
					eventCategory: 'user_activity',
					eventAction: 'close_toolbar_click'
				}
			});

			this.sidetab.hide();
			this.hide();
			App.trigger('close-slider', this.model);
		}, this);

		var activate = _.bind(function() {
			framework.extension.fireEvent('google-analytics-event', {
				data: {
					uid: this_.model.extensionUID,
					eventCategory: 'user_activity',
					eventAction: 'activate_link_click'
				}
			});
			
			this.sidetab.hide();
			this.hide(true);
			App.redirect(this.model.merchant.activation_url);
		}, this);

		var login = _.bind(function() {
			framework.extension.fireEvent('google-analytics-event', {
				data: {
					uid: this_.model.extensionUID,
					eventCategory: 'user_activity',
					eventAction: 'sign_in_click'
				}
			});

			App.trigger('login', {});
		});

		var offers = _.bind(function() {
			if (DEBUG) {
				console.log('offers', this.model.merchant.offers_url);
			}

			if (this.model.merchant.offers_url) {
				framework.extension.fireEvent('google-analytics-event', {
					data: {
						uid: this_.model.extensionUID,
						eventCategory: 'user_activity',
						eventAction: 'offers_link_click'
					}
				});

				framework.browser.navigate({
					url: this.model.merchant.offers_url + '&' + UTM_TAIL,
					tabId: framework.browser.NEWTAB
				});
			}
			
		}, this);

		var moreDetails = function() {
			if ($('#couponcabin-notification-more').attr('data-opened') == 'false') {
				$('#couponcabin-notification-more').attr('data-opened', 'true');
				$('.couponcabin-notification-right-buttons-block__more').css({
					'transform': 'rotate(180deg)'
				});
				$('#couponcabin-notification').addClass(this.model.user.user_bonus ? 'couponcabin-notification_wide' : 'couponcabin-notification_wide-without_bonus');
				$('#couponcabin-notification-container').addClass('couponcabin-notification__container_wide');
			} else {
				$('#couponcabin-notification-more').attr('data-opened', 'false');
				$('.couponcabin-notification-right-buttons-block__more').css({
					'transform': 'rotate(0deg)'
				});
				$('#couponcabin-notification').removeClass(this.model.user.user_bonus ? 'couponcabin-notification_wide' : 'couponcabin-notification_wide-without_bonus');
				$('#couponcabin-notification-container').removeClass('couponcabin-notification__container_wide');
			}
		};

		var recentActivity = function() {
			if (DEBUG) {
				console.log('recentActivity');
			}

			framework.browser.navigate({
				url: 'https://www.couponcabin.com/mycabin/cash-back/?' + UTM_TAIL,
				tabId: framework.browser.NEWTAB
			});
		};

		var paymentHistory = function() {
			if (DEBUG) {
				console.log('paymentHistory');
			}

			framework.browser.navigate({
				url: 'https://www.couponcabin.com/mycabin/cash-back/paid/?' + UTM_TAIL,
				tabId: framework.browser.NEWTAB
			});
		};

		this.events = {
			'click #couponcabin-notification-close': close,
			'click #couponcabin-notification-button-activate': activate,
			'click #couponcabin-notification-button-login': login,
			'click #couponcabin-notification-link-login': login,
			'click #couponcabin-notification-button-offers': offers,
			'click #couponcabin-notification-more': moreDetails,
			'click #couponcabin-notification-recent-activity': recentActivity,
			'click #couponcabin-notification-payment-history': paymentHistory
		};

		if (document.body) {
			try {
				this.absoluteElements = Utils.getListOfAbsoluteElements(document.body, 4);
			} catch (e) {}

			this.absoluteElements.push({
				node: document.body,
				margin: 0
			});
		}

		if (this.model.merchant.notification_text) {
			this.model.merchant.notification_cashback = this.model.merchant.notification_text.replace('back', 'cashback');
		}

		if (this.model.merchant.slider) { 
			//framework.extension.fireEvent('get-user-data');
			this.render();
		}

		this.sidetab = (new SidetabView({
			model: this.model
		})).render();

		this.listenTo(this.sidetab, "show-parent", function() {
			this.sidetab.hide(
				_.bind(function() {
					this.show();
					App.trigger('open-slider', this.model);
				}, this)
			);
		});

		if (this.model.merchant.sidetab) {
			this.showed = true, this.sidetab.show();
		} else {
			this.show();
		}
	},
	delegateEvents: function() {
		var self = this;

		if (BROWSER_NAME_IE === framework.browser.name) {
			_.each(
				this.events,
				function(callback, selector) {
					try {
						if (/^click \./i.test(selector)) {
							self.el.getElementsByClassName(selector.replace(/^click \./i, ''))[0].onclick = callback;
						} else if (/^click #/i.test(selector)) {
							window.document.getElementById(selector.replace(/^click \#/i, '')).onclick = callback;
						}
					} catch (e) {}
				});
		} else {
			return BackboneContent.View.prototype.delegateEvents.apply(this, arguments);
		}
	},
	render: function() {
		if (DEBUG) {
			console.log('[ CC ] slider model', this.model);
		}

		var view = this;
		if (this.model.user) {
			this.model.user.user_bonus = Math.round(this.model.user.user_bonus);
		}
		
		this.setElement(
			$(this.template(this.model))
				.insertAfter('head')
				.get(0)
		);

		// this.height = view.$el.height();
		this.height = 80; //-- NOTE: see in the .LESS templates height

		return this;
	},
	show: function() {
		this.model.merchant.sidetab = false;

		this.$el.animate({
			'top': '0px'
		}, {
			'duration': 500,
			'step': _.bind(
				function(y) {
					// this.moveElements(Math.floor(y) + this.height);
				}, this
			),
			'complete': _.bind(
				function() {
					$(document.body).addClass('couponcabin-body-shift');

					this.delegateEvents();
					this.sidetab.hide();

					framework.extension.fireEvent('google-analytics-pageview', {
						data: {
							'uid': this.model.extensionUID,
							'url': location.href
						}
					});
					
					if (this.model.merchant.activated && !this.showed) {
						this.showed = !this.showed;

						this.closeTimeout = window.setTimeout(
							_.bind(function() {
								this.hide();
								App.trigger('close-slider', this.model);
							}, this), this.showInterval
						);
					}
				}, this
			)
		});

		return this;
	},
	hide: function(doNotNeedToShowSidetab) {
		if (DEBUG) {
			console.log('slider hide');
		}

		this.model.merchant.sidetab = true;

		if (this.closeTimeout) {
			window.clearTimeout(this.closeTimeout);
			this.closeTimeout = null;
		}

		this.$el.animate({
			'top': '-' + this.height + 'px'
		}, {
			'duration': 500,
			'step': _.bind(
				function(y) {
					// this.moveElements(Math.floor(y) + this.height);
				}, this
			),
			'complete': _.bind(
				function() {
					$(document.body).removeClass('couponcabin-body-shift');

					!doNotNeedToShowSidetab && this.sidetab.show();
				}, this
			)
		});

		return this;
	},
	moveElements: function(offset) {
		for (var i = 0, length = this.absoluteElements.length; i < length; ++i) {
			$(this.absoluteElements[i].node)
				.css('margin-top', this.absoluteElements[i].margin + offset + 'px');
		}
	}
});
