(function () {
	injectCSS();
})();

var BG;
var APP;

$(function init() {
	if (typeof framework === 'undefined') {
		setTimeout(init, 100);
		return;
	}
	BG = framework.extension.getBackgroundPage();
	APP = BG.App;
	
	if (DEBUG) {
		console.log('BG', BG);
		console.log('APP', APP);
	}
	
	var merchant = APP.getCurrentMerchant();
	if (APP.get('usertoken')) {
		if (merchant.id){
			if (APP.user && APP.user.get('payment_method')){
				window.popup = new Popup();
			} else {
				window.close();
				framework.browser.navigate({
					'url': 'https://www.couponcabin.com/mycabin/cash-back/?' + S_CID + UTM_TAIL, 
					'tabId': framework.browser.NEWTAB
				});
			}
		} else {
			window.close();
			framework.browser.navigate({
				'url': 'https://www.couponcabin.com/?' + S_CID + UTM_TAIL, 
				'tabId': framework.browser.NEWTAB
			});
		}
	} else {
		window.close();
		framework.extension.fireEvent('google-analytics-event', {
			data: {
				uid: APP.get('uid'),
				eventCategory: 'user_activity',
				eventAction: 'sign_in_click'
			}
		});
		//framework.extension.fireEvent('login',{});
		framework.browser.navigate({
			'url': 'https://www.couponcabin.com/login/?' + S_CID + UTM_TAIL,
			'tabId': framework.browser.NEWTAB
		});
	}
});

var Popup = Backbone.Model.extend({

	initialize: function () {
		
		_.extend(this, _.object(
			[
				"app",
				"user",
				"merchant"
			],
			[
				APP,
				APP.user,
				APP.getCurrentMerchant()
			]
		));

		var self = this;
		self.layout = new PopupView({
			model: {
				usertoken: APP.get('usertoken'),
				user: self.user.toJSON(),
				merchant: self.merchant ? self.merchant.toJSON() : {},
				extensionUid: APP.get('uid')
			}
		}).render();
	}

});

var PopupView = Backbone.View.extend({
	el: "body",
	template: Handlebars.templates.popup,

	events: {
		
	},

	initialize: function () {
		window.popup = this;

		var activate = _.bind(function() {
			framework.extension.fireEvent('google-analytics-event', {
				data: {
					uid: this.model.extensionUid,
					eventCategory: 'user_activity',
					eventAction: 'activate_link_click'
				}
			});

			$('#couponcabin-popup-activated-cashback').removeClass('hide-block');
			$('#couponcabin-popup-activate-cashback-link').addClass('hide-block');
			APP.redirect(this.model.merchant.activation_url);
		}, this);

		var settings = _.bind(function() {
			$('#couponcabin-popup-main').removeClass('couponcabin-popup-main_wide');
			$('#couponcabin-popup-settings-page').addClass('couponcabin-popup-settings-page_wide');
			$('textarea#settings-blocked-sites').val(APP.blockedSliders.join('\n'));
		}, this);

		var offers = _.bind(function() {
			framework.extension.fireEvent('google-analytics-event', {
				data: {
					uid: this.model.extensionUid,
					eventCategory: 'user_activity',
					eventAction: 'offers_link_click'
				}
			});

			if (this.model.merchant.offers_url) {
				framework.browser.navigate({
					url: this.model.merchant.offers_url + '&' + UTM_TAIL,
					tabId: framework.browser.NEWTAB
				});
			}
		}, this);

		var activity = function() {
			framework.browser.navigate({
				url: 'https://www.couponcabin.com/mycabin/cash-back/?' + S_CID + UTM_TAIL,
				tabId: framework.browser.NEWTAB
			});
		};

		var edit = function() {
			framework.browser.navigate({
				url: 'https://www.couponcabin.com/mycabin/preferences/profile_settings/?' + S_CID + UTM_TAIL,
				tabId: framework.browser.NEWTAB
			});
		};

		var settingsCancel = _.bind(function() {
			$('#couponcabin-popup-main').addClass('couponcabin-popup-main_wide');
			$('#couponcabin-popup-settings-page').removeClass('couponcabin-popup-settings-page_wide');
			$('textarea#settings-blocked-sites').val('');
		}, this);

		var settingsSave =  _.bind(function() {
				var blocked = $('textarea#settings-blocked-sites').val().split('\n');
				blocked = _.compact(blocked);
				blocked = _.uniq(blocked);
				blocked = blocked.map(function(blockedDomain){
					return Utils.getDomain(blockedDomain);
				});			
				APP.blockedSliders = blocked;
				console.warn('Blocked Sliders', APP.blockedSliders);
				framework.extension.setItem('blockedSliders', APP.blockedSliders.join(' '));

				framework.extension.fireEvent('google-analytics-event', {
					data: {
						uid: this.model.extensionUid,
						eventCategory: 'user_activity',
						eventAction: 'save_settings'
					}
				});
				
				$('#couponcabin-popup-main').addClass('couponcabin-popup-main_wide');
				$('#couponcabin-popup-settings-page').removeClass('couponcabin-popup-settings-page_wide');
				$('textarea#settings-blocked-sites').val('');	
		}, this);

		this.events = {
			'click #couponcabin-popup-settings-link': settings,
			'click #couponcabin-popup-offers-link': offers,
			'click #couponcabin-popup-activity-link': activity,
			'click #couponcabin-popup-edit-link': edit,
			'click #couponcabin-popup-settings-cancel': settingsCancel,
			'click #couponcabin-popup-settings-save': settingsSave,
			'click #couponcabin-popup-activate-cashback-link': activate
		};

		if (DEBUG) {
			console.log('Model', this.model);
		}
	},

	render: function () {
		var self = this;
		if (this.model.merchant.notification_text) {
			this.model.merchant.notification_cashback = this.model.merchant.notification_text.replace('back', 'cashback');
		}
		self.$el.prepend(self.template(self.model));
		return self;
	}
	
});