
var Utils = (function() {
	
	var self = {};
	
	self.getDomain = function(url) {
		var match;
		
		if (url){
			match = /^(?:https?:\/\/)?(?:www[1-9]*\.)?([^:\/\n]+)/i.exec(url);
		}
		
		return match && match[1].toLowerCase();
	};
	
	self.getStyle = function(element, cssProperty) {
		if (element.currentStyle) {
			return element.currentStyle[cssProperty];
		} else if (window.document.defaultView && window.document.defaultView.getComputedStyle) {
			var style = window.document.defaultView.getComputedStyle(element, '');
			return style ? style[cssProperty] : null;
		} else if (element.style) {
			return element.style[cssProperty];
		}
	};
	
	self.getListOfAbsoluteElements = function(parent, deep, opt_parentIsAbsolute) {
		var list = [];
		
		for (
			var i = 0
			; i < parent.childNodes.length
			; ++i
		) {
			if (
				parent.childNodes[i]
				&& 1 === parent.childNodes[i].nodeType
			) {
				var pos = this.getStyle(parent.childNodes[i], 'position');
				
				if (!opt_parentIsAbsolute && 'absolute' === pos || 'fixed' === pos) {
					if ( 'auto' !== this.getStyle(parent.childNodes[i], 'top') ) {
						var margin = this.getStyle(parent.childNodes[i], 'margin-top');
						
						list.push({
							node : parent.childNodes[i]
							, margin : margin ? margin.replace("px", "") : 0
						});
					}
				}
				
				var abs = ('absolute' === pos || 'fixed' === pos || 'relative' === pos) || opt_parentIsAbsolute;
				if (parent.childNodes[i].childNodes && 0 < deep) {
					var res = this.getListOfAbsoluteElements(
						parent.childNodes[i]
						, deep - 1
						, abs
					);
					
					if (res && res.length) {
						list = list.concat(res);
					}
				}
			}
		}
		
		return list;
	};
	
	self.guid = function() {
		return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
			var r = Math.random() * 16 | 0, v = c == "x" ? r : (r & 0x3 | 0x8);
			return v.toString(16);
		});
	};
	
	return self;
	
})();

